package org.apache.ojb.broker;

import java.sql.SQLException;

/* Copyright 2002-2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * 
 * @author <a href="mailto:thomas.mahler@itellium.com">Thomas Mahler<a>
 * @version $Id: PersistenceBrokerSQLException.java,v 1.8 2004/04/04 23:53:30 brianm Exp $
 * 
 */ 
public class PersistenceBrokerSQLException extends PersistenceBrokerException
{
	private String m_sqlState = null;
	
    public PersistenceBrokerSQLException()
    {
        super();
    }

    public PersistenceBrokerSQLException(SQLException t)
    {
        super(t);
        m_sqlState = t.getSQLState();
    }
    
    public PersistenceBrokerSQLException(String message)
    {
        super(message);
    }

    public PersistenceBrokerSQLException(String message, SQLException t)
    {
        super(message,t);
        m_sqlState = t.getSQLState();
    }
}
