package org.apache.ojb.odmg.locking;

/* Copyright 2002-2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.apache.ojb.broker.OJBRuntimeException;
import org.apache.ojb.broker.PersistenceBrokerFactory;
import org.apache.ojb.broker.util.ClassHelper;

/**
 * This factory class creates LockManager instances according
 * to the setting in the OJB properties file.
 */
public class LockManagerFactory
{
    private static LockManager LOCKMAN = null;
    static
    {
        try
        {
            LockingConfiguration config = (LockingConfiguration) PersistenceBrokerFactory.getConfigurator().getConfigurationFor(null);
            LOCKMAN = (LockManager) ClassHelper.newInstance(config.getLockManagerClass());
        }
        catch (Exception e)
        {
            throw new OJBRuntimeException("Unexpected failure while start LockManager", e);
        }
    }

    /**
     * get a lockManager instance. The implementation class is
     * configured in the OJB properties file.
     */
    public static LockManager getLockManager()
    {
        return LOCKMAN;
    }
}
