package org.apache.ojb.broker;

import java.util.List;
import java.io.Serializable;

//#ifdef JDK13
import java.lang.reflect.InvocationHandler;

import org.apache.ojb.broker.core.proxy.*;
//#else
/*
import com.develop.java.lang.reflect.InvocationHandler;
*/
//#endif

/**
 * Proxy class for ProductGroup.
 */
public class ProductGroupProxy extends VirtualProxy implements InterfaceProductGroup, Serializable
{
    public ProductGroupProxy()
    {
    }

    /**
     * ProductGroupProxy constructor comment.
     * @param uniqueId org.apache.ojb.broker.Identity
     */
    public ProductGroupProxy(PBKey key, Identity uniqueId)
    {
        super(key, uniqueId);
    }

    public ProductGroupProxy(InvocationHandler handler)
    {
        super(handler);
    }


    /** return List of all Articles in productgroup*/
    public List getAllArticles()
    {
        return realSubject().getAllArticles();
    }

    /** return group id*/
    public int getId()
    {
        return realSubject().getId();
    }

    /** return groupname*/
    public String getName()
    {
        return realSubject().getName();
    }

    /**
     * Insert the method's description here.
     * Creation date: (08.11.2000 22:38:26)
     * @return org.apache.ojb.examples.broker.Article
     */
    private ProductGroup realSubject()
    {
        try
        {
            ProductGroup result = (ProductGroup) getRealSubject();
            if (result == null) throw new NullPointerException("Real subject was null");
            return result;
        }
        catch (Throwable t)
        {
            System.out.println(t.getMessage());
            t.printStackTrace();
            return null;
        }
    }

    /**
     * Insert the method's description here.
     * Creation date: (09.11.2000 21:13:06)
     * @return java.lang.String
     */
    public String toString()
    {
        return realSubject().toString();
    }

    /** add article to group*/
    public void add(InterfaceArticle article)
    {
        realSubject().add(article);
    }
}
