package org.apache.ojb.junit;

import org.apache.ojb.broker.PersistenceBroker;
import org.apache.ojb.broker.PersistenceBrokerFactory;

/**
 * A base class for PB-api based test cases.
 * NOTE: The PB instance is declared <tt>public</tt> (no getter/setter) for easy use.
 *
 * @author <a href="mailto:arminw@apache.org">Armin Waibel</a>
 * @version $Id: PBTestCase.java,v 1.3 2004/06/22 18:16:22 arminw Exp $
 */
public class PBTestCase extends OJBTestCase
{
    public PersistenceBroker broker;

    public PBTestCase()
    {
    }

    public PBTestCase(String name)
    {
        super(name);
    }

    public void setUp() throws Exception
    {
        super.setUp();
        broker = PersistenceBrokerFactory.defaultPersistenceBroker();
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
        if(broker != null)
        {
            broker.close();
        }
    }
}
