package org.apache.ojb.odmg.shared;

import org.apache.ojb.broker.Gourmet;
import org.apache.ojb.broker.TestHelper;
import org.apache.ojb.odmg.collections.DCollectionFactory;
import org.odmg.DList;

/**
 * class used to test polymorphic m:n collections (ODMG-variant)
 * @author <a href="mailto:schneider@mendel.imp.univie.ac.at">Georg Schneider</a>
 *
 */
public class ODMGGourmet extends Gourmet
{

    /**
     * Constructor for ODMGGourmet.
     */
    public ODMGGourmet()
    {
        super();
        DList list = DCollectionFactory.getInstance().createDList(TestHelper.DEF_KEY);
        this.setFavoriteFood(list);
    }

    /**
     * Constructor for ODMGGourmet.
     * @param name
     */
    public ODMGGourmet(String name)
    {
        super(name);
        DList list = DCollectionFactory.getInstance().createDList(TestHelper.DEF_KEY);
        this.setFavoriteFood(list);
    }

}
