package org.apache.ojb.tools.mapping.reversedb.gui;

/* Copyright 2002-2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *
 * @author <a href="mailto:bfl@florianbruckner.com">Florian Bruckner</a> 
 * @version $Id: DBMetaPropertySheet.java,v 1.1 2004/05/05 16:38:49 arminw Exp $
 */
public class DBMetaPropertySheet extends javax.swing.JPanel
  implements PropertySheetView
{
    org.apache.ojb.tools.mapping.reversedb.DBMeta aMeta;
  /** Creates new form DBCatalogPropertySheet */
  public DBMetaPropertySheet ()
  {
    initComponents ();
  }
  
  private void readValuesFromMeta()
  {
    this.cbEnabled.setSelected(aMeta.isEnabled());
    this.tfCatalogTerm.setText(aMeta.getCatalogTerm());
    this.tfSupportsCatalogInDML.setText("" + aMeta.getSupportsCatalogsInDataManipulation ());
    this.tfSupportsCatalogInIndex.setText("" + aMeta.getSupportsCatalogsInIndexDefinitions());
    this.tfSupportsCatalogInPrivilegeDefinitions.setText("" + aMeta.getSupportsCatalogsInPrivilegeDefinitions ());
    this.tfSupportsCatalogInProcedureCalls.setText("" + aMeta.getSupportsCatalogsInProcedureCalls ());
    this.tfSupportsCatalogInTableDefinitions.setText("" + aMeta.getSupportsCatalogsInTableDefinitions ());
    this.tfSchemaTerm.setText(aMeta.getSchemaTerm());
    this.tfProductName.setText(aMeta.getDatabaseProductName ());
    this.tfProductVersion.setText(aMeta.getDatabaseProductVersion ());
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        lblEnabled = new javax.swing.JLabel();
        cbEnabled = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        lblProductName = new javax.swing.JLabel();
        tfProductName = new javax.swing.JTextField();
        lblProductVersion = new javax.swing.JLabel();
        tfProductVersion = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        lblCatalogTerm = new javax.swing.JLabel();
        tfCatalogTerm = new javax.swing.JTextField();
        lblCatalogSeparator = new javax.swing.JLabel();
        tfCatalogSeparator = new javax.swing.JTextField();
        lblSupportsCatalogInIndex = new javax.swing.JLabel();
        tfSupportsCatalogInIndex = new javax.swing.JTextField();
        lblSupportsCatalogInDML = new javax.swing.JLabel();
        tfSupportsCatalogInDML = new javax.swing.JTextField();
        lblSupportsCatalogInPrivilegeDefinitions = new javax.swing.JLabel();
        tfSupportsCatalogInPrivilegeDefinitions = new javax.swing.JTextField();
        lblSupportsCatalogInProcedureCalls = new javax.swing.JLabel();
        tfSupportsCatalogInProcedureCalls = new javax.swing.JTextField();
        lblSupportsCatalogInTableDefinitions = new javax.swing.JLabel();
        tfSupportsCatalogInTableDefinitions = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblSchemaTerm = new javax.swing.JLabel();
        tfSchemaTerm = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentShown(java.awt.event.ComponentEvent evt)
            {
                formComponentShown(evt);
            }
            public void componentHidden(java.awt.event.ComponentEvent evt)
            {
                formComponentHidden(evt);
            }
        });

        addHierarchyListener(new java.awt.event.HierarchyListener()
        {
            public void hierarchyChanged(java.awt.event.HierarchyEvent evt)
            {
                formHierarchyChanged(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(19, 2));

        lblEnabled.setText("enabled");
        lblEnabled.setDisplayedMnemonic('e');
        jPanel1.add(lblEnabled);

        cbEnabled.setMnemonic('e');
        cbEnabled.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cbEnabledActionPerformed(evt);
            }
        });

        jPanel1.add(cbEnabled);

        jPanel1.add(jLabel1);

        jPanel1.add(jLabel2);

        lblProductName.setText("Database Product Name:");
        jPanel1.add(lblProductName);

        tfProductName.setEditable(false);
        tfProductName.setText("jTextField1");
        tfProductName.setBorder(null);
        jPanel1.add(tfProductName);

        lblProductVersion.setText("Database Product Version:");
        jPanel1.add(lblProductVersion);

        tfProductVersion.setEditable(false);
        tfProductVersion.setText("jTextField2");
        tfProductVersion.setBorder(null);
        jPanel1.add(tfProductVersion);

        jPanel1.add(jLabel8);

        jPanel1.add(jLabel7);

        lblCatalogTerm.setText("Catalog Term:");
        lblCatalogTerm.setLabelFor(tfCatalogTerm);
        jPanel1.add(lblCatalogTerm);

        tfCatalogTerm.setEditable(false);
        tfCatalogTerm.setText("jTextField1");
        tfCatalogTerm.setBorder(null);
        jPanel1.add(tfCatalogTerm);

        lblCatalogSeparator.setText("Catalog Separator:");
        lblCatalogSeparator.setLabelFor(tfCatalogSeparator);
        jPanel1.add(lblCatalogSeparator);

        tfCatalogSeparator.setEditable(false);
        tfCatalogSeparator.setText("jTextField1");
        tfCatalogSeparator.setBorder(null);
        jPanel1.add(tfCatalogSeparator);

        lblSupportsCatalogInIndex.setText("supports Catalog in Index:");
        lblSupportsCatalogInIndex.setLabelFor(tfSupportsCatalogInIndex);
        jPanel1.add(lblSupportsCatalogInIndex);

        tfSupportsCatalogInIndex.setEditable(false);
        tfSupportsCatalogInIndex.setText("jTextField1");
        tfSupportsCatalogInIndex.setBorder(null);
        jPanel1.add(tfSupportsCatalogInIndex);

        lblSupportsCatalogInDML.setText("supports Catalog in DML:");
        lblSupportsCatalogInDML.setLabelFor(lblSupportsCatalogInDML);
        jPanel1.add(lblSupportsCatalogInDML);

        tfSupportsCatalogInDML.setEditable(false);
        tfSupportsCatalogInDML.setText("jTextField1");
        tfSupportsCatalogInDML.setBorder(null);
        jPanel1.add(tfSupportsCatalogInDML);

        lblSupportsCatalogInPrivilegeDefinitions.setText("supports Catalog in Privilege Definitions:");
        lblSupportsCatalogInPrivilegeDefinitions.setLabelFor(tfSupportsCatalogInPrivilegeDefinitions);
        jPanel1.add(lblSupportsCatalogInPrivilegeDefinitions);

        tfSupportsCatalogInPrivilegeDefinitions.setEditable(false);
        tfSupportsCatalogInPrivilegeDefinitions.setText("jTextField1");
        tfSupportsCatalogInPrivilegeDefinitions.setBorder(null);
        jPanel1.add(tfSupportsCatalogInPrivilegeDefinitions);

        lblSupportsCatalogInProcedureCalls.setText("supports Catalog in Procedure Calls:");
        lblSupportsCatalogInProcedureCalls.setLabelFor(tfSupportsCatalogInProcedureCalls);
        jPanel1.add(lblSupportsCatalogInProcedureCalls);

        tfSupportsCatalogInProcedureCalls.setEditable(false);
        tfSupportsCatalogInProcedureCalls.setText("jTextField1");
        tfSupportsCatalogInProcedureCalls.setBorder(null);
        jPanel1.add(tfSupportsCatalogInProcedureCalls);

        lblSupportsCatalogInTableDefinitions.setText("supports Catalog in Table Definitions:");
        lblSupportsCatalogInTableDefinitions.setLabelFor(tfSupportsCatalogInTableDefinitions);
        jPanel1.add(lblSupportsCatalogInTableDefinitions);

        tfSupportsCatalogInTableDefinitions.setEditable(false);
        tfSupportsCatalogInTableDefinitions.setText("jTextField1");
        tfSupportsCatalogInTableDefinitions.setBorder(null);
        jPanel1.add(tfSupportsCatalogInTableDefinitions);

        jPanel1.add(jLabel4);

        jPanel1.add(jLabel3);

        lblSchemaTerm.setText("Schema Term:");
        lblSchemaTerm.setLabelFor(tfSchemaTerm);
        jPanel1.add(lblSchemaTerm);

        tfSchemaTerm.setEditable(false);
        tfSchemaTerm.setText("jTextField1");
        tfSchemaTerm.setBorder(null);
        jPanel1.add(tfSchemaTerm);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

    }//GEN-END:initComponents

  private void cbEnabledActionPerformed (java.awt.event.ActionEvent evt)//GEN-FIRST:event_cbEnabledActionPerformed
  {//GEN-HEADEREND:event_cbEnabledActionPerformed
    // Add your handling code here:
    aMeta.setEnabled(cbEnabled.isSelected());
  }//GEN-LAST:event_cbEnabledActionPerformed

  private void formHierarchyChanged (java.awt.event.HierarchyEvent evt)//GEN-FIRST:event_formHierarchyChanged
  {//GEN-HEADEREND:event_formHierarchyChanged
    // Add your handling code here:
    readValuesFromMeta();    
  }//GEN-LAST:event_formHierarchyChanged

  private void formComponentHidden (java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentHidden
  {//GEN-HEADEREND:event_formComponentHidden
    // Add your handling code here:
  }//GEN-LAST:event_formComponentHidden

  private void formComponentShown (java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    // Add your handling code here:
  }//GEN-LAST:event_formComponentShown

  public void setModel (PropertySheetModel pm)
  {
    if (pm instanceof org.apache.ojb.tools.mapping.reversedb.DBMeta)
    {
      this.aMeta = (org.apache.ojb.tools.mapping.reversedb.DBMeta)pm;
      this.readValuesFromMeta();
    }
    else
      throw new IllegalArgumentException();        
  }  
  
  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField tfSchemaTerm;
    private javax.swing.JLabel lblSupportsCatalogInDML;
    private javax.swing.JLabel lblProductVersion;
    private javax.swing.JTextField tfSupportsCatalogInDML;
    private javax.swing.JTextField tfProductVersion;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lblEnabled;
    private javax.swing.JLabel lblCatalogSeparator;
    private javax.swing.JCheckBox cbEnabled;
    private javax.swing.JTextField tfCatalogSeparator;
    private javax.swing.JTextField tfSupportsCatalogInTableDefinitions;
    private javax.swing.JTextField tfSupportsCatalogInPrivilegeDefinitions;
    private javax.swing.JLabel lblSupportsCatalogInTableDefinitions;
    private javax.swing.JLabel lblSupportsCatalogInPrivilegeDefinitions;
    private javax.swing.JTextField tfCatalogTerm;
    private javax.swing.JLabel lblCatalogTerm;
    private javax.swing.JLabel lblSupportsCatalogInIndex;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField tfSupportsCatalogInProcedureCalls;
    private javax.swing.JTextField tfSupportsCatalogInIndex;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField tfProductName;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lblSupportsCatalogInProcedureCalls;
    private javax.swing.JLabel lblProductName;
    private javax.swing.JLabel lblSchemaTerm;
    // End of variables declaration//GEN-END:variables
  
}

/***************************** Changelog *****************************
// $Log: DBMetaPropertySheet.java,v $
// Revision 1.1  2004/05/05 16:38:49  arminw
// fix fault
// wrong package structure used:
// org.apache.ojb.tools.reversdb
// org.apache.ojb.tools.reversdb2
//
// instead of
// org.apache.ojb.tools.mapping.reversdb
// org.apache.ojb.tools.mapping.reversdb2
//
// Revision 1.1  2004/05/04 13:44:59  arminw
// move reverseDB stuff
//
// Revision 1.6  2004/04/05 12:16:23  tomdz
// Fixed/updated license in files leftover from automatic license transition
//
// Revision 1.5  2004/04/04 23:53:42  brianm
// Fixed initial copyright dates to match cvs repository
//
// Revision 1.4  2004/03/11 18:16:22  brianm
// ASL 2.0
//
// Revision 1.3  2002/06/18 12:26:41  florianbruckner
// changes in Netbeans Form definitions after move to jakarta.
//
// Revision 1.2  2002/06/17 19:34:34  jvanzyl
// Correcting all the package references.
// PR:
// Obtained from:
// Submitted by:
// Reviewed by:
//
// Revision 1.1.1.1  2002/06/17 18:16:53  jvanzyl
// Initial OJB import
//
// Revision 1.2  2002/05/16 11:47:09  florianbruckner
// fix CR/LF issue, change license to ASL
//
// Revision 1.1  2002/04/18 11:44:16  mpoeschl
//
// move files to new location
//
// Revision 1.3  2002/04/07 09:05:17  thma
// *** empty log message ***
//
// Revision 1.2  2002/03/11 17:36:26  florianbruckner
// fix line break issue for these files that were previously checked in with -kb
//
// Revision 1.1  2002/03/04 17:19:32  thma
// initial checking for Florians Reverse engineering tool
//
// Revision 1.1.1.1  2002/02/20 13:35:25  Administrator
// initial import
//
/***************************** Changelog *****************************/
 
