package org.apache.ojb.tools.mapping.reversedb.gui;

/* Copyright 2002-2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *
 * @author <a href="mailto:bfl@florianbruckner.com">Florian Bruckner</a> 
 * @version $Id: DBSchemaPropertySheet.java,v 1.1 2004/05/05 16:38:49 arminw Exp $
 */
public class DBSchemaPropertySheet extends javax.swing.JPanel
  implements PropertySheetView
{
    org.apache.ojb.tools.mapping.reversedb.DBSchema aSchema;
  /** Creates new form DBCatalogPropertySheet */
  public DBSchemaPropertySheet ()
  {
    initComponents ();
  }
  
  private void readValuesFromSchema()
  {
    this.tfSchemaName.setText(aSchema.getSchemaName());
    this.cbEnabled.setSelected(aSchema.isEnabled());
    this.cbDisabledByParent.setSelected(!aSchema.getDBCatalog().isTreeEnabled ());
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        lblEnabled = new javax.swing.JLabel();
        cbEnabled = new javax.swing.JCheckBox();
        lblDisabledByParent = new javax.swing.JLabel();
        cbDisabledByParent = new javax.swing.JCheckBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblSchemaName = new javax.swing.JLabel();
        tfSchemaName = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentShown(java.awt.event.ComponentEvent evt)
            {
                formComponentShown(evt);
            }
            public void componentHidden(java.awt.event.ComponentEvent evt)
            {
                formComponentHidden(evt);
            }
        });

        addHierarchyListener(new java.awt.event.HierarchyListener()
        {
            public void hierarchyChanged(java.awt.event.HierarchyEvent evt)
            {
                formHierarchyChanged(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(4, 2));

        lblEnabled.setText("enabled");
        lblEnabled.setDisplayedMnemonic('e');
        jPanel1.add(lblEnabled);

        cbEnabled.setMnemonic('e');
        cbEnabled.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cbEnabledActionPerformed(evt);
            }
        });

        jPanel1.add(cbEnabled);

        lblDisabledByParent.setText("disabled by Parent:");
        jPanel1.add(lblDisabledByParent);

        cbDisabledByParent.setEnabled(false);
        cbDisabledByParent.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cbDisabledByParentActionPerformed(evt);
            }
        });

        jPanel1.add(cbDisabledByParent);

        jPanel1.add(jLabel4);

        jPanel1.add(jLabel3);

        lblSchemaName.setText("Schema Name:");
        lblSchemaName.setLabelFor(tfSchemaName);
        jPanel1.add(lblSchemaName);

        tfSchemaName.setEditable(false);
        tfSchemaName.setText("jTextField1");
        tfSchemaName.setBorder(null);
        jPanel1.add(tfSchemaName);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

    }//GEN-END:initComponents

  private void cbEnabledActionPerformed (java.awt.event.ActionEvent evt)//GEN-FIRST:event_cbEnabledActionPerformed
  {//GEN-HEADEREND:event_cbEnabledActionPerformed
    // Add your handling code here:
    this.aSchema.setEnabled(cbEnabled.isSelected());
  }//GEN-LAST:event_cbEnabledActionPerformed

  private void cbDisabledByParentActionPerformed (java.awt.event.ActionEvent evt)//GEN-FIRST:event_cbDisabledByParentActionPerformed
  {//GEN-HEADEREND:event_cbDisabledByParentActionPerformed
    // Add your handling code here:
  }//GEN-LAST:event_cbDisabledByParentActionPerformed

  private void formHierarchyChanged (java.awt.event.HierarchyEvent evt)//GEN-FIRST:event_formHierarchyChanged
  {//GEN-HEADEREND:event_formHierarchyChanged
    // Add your handling code here:
    readValuesFromSchema();    
  }//GEN-LAST:event_formHierarchyChanged

  private void formComponentHidden (java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentHidden
  {//GEN-HEADEREND:event_formComponentHidden
    // Add your handling code here:
  }//GEN-LAST:event_formComponentHidden

  private void formComponentShown (java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    // Add your handling code here:
  }//GEN-LAST:event_formComponentShown

  public void setModel (PropertySheetModel pm)
  {
    if (pm instanceof org.apache.ojb.tools.mapping.reversedb.DBSchema)
    {
      this.aSchema = (org.apache.ojb.tools.mapping.reversedb.DBSchema)pm;
      this.readValuesFromSchema();
    }
    else
      throw new IllegalArgumentException();    
    
  }  
  
  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cbDisabledByParent;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lblEnabled;
    private javax.swing.JLabel lblSchemaName;
    private javax.swing.JCheckBox cbEnabled;
    private javax.swing.JTextField tfSchemaName;
    private javax.swing.JLabel lblDisabledByParent;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
  
}

/***************************** changelog *****************************
// $log$
/***************************** changelog *****************************/
